<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/resumeApprove">resumeApprove管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form
      ref="queryForm"
      :model="queryModel"
      inline
      class="demo-form-inline"
    >
      <el-form-item label="" prop="id">
        <el-input type="text" size="mini" v-model="queryModel.id"></el-input>
      </el-form-item>
      <el-form-item label="" prop="createBy">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.createBy"
        ></el-input>
      </el-form-item>
      <el-form-item label="" prop="createTime">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.createTime"
        ></el-input>
      </el-form-item>
      <el-form-item label="" prop="updateBy">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.updateBy"
        ></el-input>
      </el-form-item>
      <el-form-item label="" prop="updateTime">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.updateTime"
        ></el-input>
      </el-form-item>
      <el-form-item label="删除标示" prop="delFlag">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.delFlag"
        ></el-input>
      </el-form-item>
      <el-form-item label="用户ID" prop="jobResumeId">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.jobResumeId"
        ></el-input>
      </el-form-item>
      <el-form-item label="审批人" prop="approvePersonId">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.approvePersonId"
        ></el-input>
      </el-form-item>
      <el-form-item label="审批时间" prop="approveTime">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.approveTime"
        ></el-input>
      </el-form-item>
      <el-form-item label="审批状态" prop="approvalStatus">
        <el-input
          type="text"
          size="mini"
          v-model="queryModel.approvalStatus"
        ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
          >查询</el-button
        >&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
          >重置</el-button
        >&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        @click="handleAdd"
        >新增</el-button
      >
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-circle-plus"
        :disabled="multipleSelection.length == 0"
        @click="handleBatchDelete"
        >删除选中项</el-button
      >
    </el-row>
    <el-table
      :data="tableData"
      style="min-height: 400px"
      v-loading="loading"
      stripe
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="id" label="" width="180"></el-table-column>
      <el-table-column prop="createBy" label="" width="180"></el-table-column>
      <el-table-column prop="createTime" label="" width="180"></el-table-column>
      <el-table-column prop="updateBy" label="" width="180"></el-table-column>
      <el-table-column prop="updateTime" label="" width="180"></el-table-column>
      <el-table-column
        prop="delFlag"
        label="删除标示"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="jobResumeId"
        label="用户ID"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="approvePersonId"
        label="审批人"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="approveTime"
        label="审批时间"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="approvalStatus"
        label="审批状态"
        width="180"
      ></el-table-column>
      <el-table-column label="操作">
        <template slot-scope="{ row }">
          <el-button size="mini" type="warning" @click="handleEdit(row)"
            >编辑</el-button
          >
          <el-button size="mini" type="danger" @click="handleDelete(row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <resumeApprove-detail
      v-if="showModal"
      :businessKey="businessKey"
      :title="modalTitle"
      @close="onDetailModalClose"
    ></resumeApprove-detail>
  </div>
</template>
<script>
import Constant from "@/constant";
import ResumeApproveDetail from "./resumeApprove-detail";
import resumeApproveApi from "@/api/base/base/resumeApprove";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  data() {
    var self = this;

    return {
      queryModel: {
        id: "",
        createBy: "",
        createTime: "",
        updateBy: "",
        updateTime: "",
        delFlag: "",
        jobResumeId: "",
        approvePersonId: "",
        approveTime: "",
        approvalStatus: "",
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      showModal: false,
      modalTitle: "",
      businessKey: "",
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;

      self.loading = true;

      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("id", self.queryModel.id);
      formData.append("createBy", self.queryModel.createBy);
      formData.append("createTime", self.queryModel.createTime);
      formData.append("updateBy", self.queryModel.updateBy);
      formData.append("updateTime", self.queryModel.updateTime);
      formData.append("delFlag", self.queryModel.delFlag);
      formData.append("jobResumeId", self.queryModel.jobResumeId);
      formData.append("approvePersonId", self.queryModel.approvePersonId);
      formData.append("approveTime", self.queryModel.approveTime);
      formData.append("approvalStatus", self.queryModel.approvalStatus);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      resumeApproveApi
        .pageList(formData)
        .then(function (response) {
          self.loading = false;

          var jsonData = response.data.data;

          self.tableData = jsonData.data;
          self.totalPages = jsonData.totalPages;
          self.totalElements = jsonData.recordsTotal;
        })
        .catch((error) => {
          self.loading = false;
          // self.$message.error(error + "");
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;

      this.$nextTick(() => {
        this.changePage(this.pageIndex);
      });
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      this.modalTitle = "新增";
      this.businessKey = "";
      this.showModal = true;
    },
    handleEdit(record) {
      this.modalTitle = "编辑";
      this.businessKey = record.id;
      this.showModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
        .then(() => {
          resumeApproveApi.remove(record.id).then(function (response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!",
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map((record) => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        resumeApproveApi.batchRemove(idList).then(function (response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!",
            });
          }
        });
      });
    },
    onDetailModalClose(refreshed) {
      //保存成功后回调
      this.showModal = false;

      if (refreshed) {
        this.changePage(this.pageIndex);
      }
    },
  },
  mounted: function () {
    this.changePage(1);
  },
  components: {
    "resumeApprove-detail": ResumeApproveDetail,
  },
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  margin-left: 10px;
  text-align: left;
}
</style>